Name:           pulseaudio-module-xrdp
Version:        0.8
Release:        1%{?dist}
Summary:        xrdp pulseaudio module

License:        LGPL-2.1-only
URL:            https://github.com/neutrinolabs/pulseaudio-module-xrdp
Source0:        https://github.com/neutrinolabs/pulseaudio-module-xrdp/archive/refs/tags/v%{version}.tar.gz

BuildRequires:  git
BuildRequires:  gcc
BuildRequires:  dnf
BuildRequires:  libsndfile-devel
BuildRequires:  meson
BuildRequires:  libtool
BuildRequires:  libtool-ltdl-devel
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtdb-devel
BuildRequires:  check
BuildRequires:  pulseaudio-libs-devel

Requires:       pulseaudio
Requires:       xrdp

ExclusiveArch:  i686 x86_64 armv6hl armv7hl aarch64

%global pulse_repo https://gitlab.freedesktop.org/pulseaudio/pulseaudio

%description
PulseAudio modules for XRDP to enable remote desktop audio forwarding over RDP.

%prep
%setup -q -n %{name}-%{version}
# Clone pulseaudio source
git clone %{pulse_repo}.git %{_builddir}/pulseaudio.gitlab

%build
echo "Building pulseaudio..."

_pulseaudio_ver=$(dnf --quiet --refresh info pulseaudio | awk '/^Version/ {v=$3} /^Release/ {r=$3} END {print v "-" r}')
if grep -qm1 '+' <<< "$_pulseaudio_ver"; then
  _ref=$(sed -E 's&^\S+[+]g([a-f0-9]+)-\S+$&\1&' <<< ${_pulseaudio_ver})
else
  _ref=v$(sed -E 's&^([0-9]+\.[0-9]+).*$&\1&' <<< ${_pulseaudio_ver})
fi

pushd %{_builddir}/pulseaudio.gitlab
git -c advice.detachedHead=false checkout -f "${_ref:?}"
meson build -Ddoxygen=false -Dtests=false
popd

echo "Building pulseaudio-module-xrdp..."

pushd .
sed -i '\#-I $(PULSE_DIR)/src#a -I $(PULSE_DIR)/build \\' src/Makefile.am

autoreconf -ivf
./configure PULSE_DIR=%{_builddir}/pulseaudio.gitlab --prefix='/usr' --libexecdir='/usr/lib'
make %{?_smp_mflags}
popd

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} install

# Remove .la files (not needed)
find %{buildroot} -name '*.la' -delete

%files
%license LICENSE
%doc README.md

# PulseAudio modules
%{_libdir}/pulseaudio/modules/module-xrdp-*.so

# Extra scripts and desktop entries
/usr/lib/pulseaudio-module-xrdp/load_pa_modules.sh
/etc/xdg/autostart/pulseaudio-xrdp.desktop

%changelog
* Wed Apr 16 2025 Jat <chat@jat.email> - 0.8-1
- Initial RPM release
